﻿'=========================================VisualMonsters.cba.pl===================================================
Public Class Form1
    'Main board size
    Dim bHeight As Integer = 15
    Dim bWidth As Integer = 20
    Dim PLocationList As New List(Of List(Of Panel)) 'all panels on the board list


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        For i As Integer = -2 To bWidth + 1
            Dim PanList As New List(Of Panel)
            For j As Integer = -2 To bHeight + 1
                Dim MainPanel As New Panel
                With MainPanel
                    .Location = New Point(i * 40 + 30, j * 40 + 30)
                    .Size = New Size(20, 20)
                    .BackColor = Color.Transparent
                    .Name = "panL_" + i.ToString + "^" + j.ToString + "^"
                    .Cursor = Cursors.Hand
                    AddHandler .Click, AddressOf pan_Click
                    'Cross out the board, explain on the tutorial
                    If i = -2 Or i = -1 Or j = -1 Or j = -2 Or i = bWidth Or j = bHeight Or i = bWidth + 1 Or j = bHeight + 1 Then
                        .Enabled = False
                    End If
                End With
                Main_board.Controls.Add(MainPanel) ' Add items to the panel
                PanList.Add(MainPanel)
            Next
            'The variable stores all board panels
            PLocationList.Add(PanList)
        Next
        'generate board grid
        Dim bit As Bitmap = New Bitmap(Main_board.Width, Main_board.Height)
        Dim g As Graphics = Graphics.FromImage(bit)

        Dim myPen As Pen = New Pen(Color.FromArgb(191, 218, 229), 1)
        For i As Integer = 40 To Main_board.Height Step 40
            g.DrawLine(myPen, 0, i, Main_board.Width, i)
        Next
        For i As Integer = 40 To Main_board.Width Step 40
            g.DrawLine(myPen, i, 0, i, Main_board.Height)
        Next
        Main_board.BackgroundImage = bit
    End Sub

    'Current player
    Dim Player As Boolean = True
    'dots list
    Dim Player1DotsL As New List(Of Panel)
    Dim Player2DotsL As New List(Of Panel)
    Dim bit As Bitmap
    Dim g As Graphics
    'Colors
    Dim pGreen As New System.Drawing.SolidBrush(System.Drawing.Color.Green)
    Dim pRed As New System.Drawing.SolidBrush(Color.Red)

    Public Sub pan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If Player Then 'green
            bit = New Bitmap(20, 20)
            g = Graphics.FromImage(bit)
            'Added a checked panel to the list
            Player1DotsL.Add(DirectCast(sender, Panel))
            g.FillEllipse(pGreen, New Rectangle(5, 5, 10, 10))
            DirectCast(sender, Panel).BackgroundImage = bit
            DirectCast(sender, Panel).Enabled = False
            LapTest()
        Else 'red
            bit = New Bitmap(20, 20)
            g = Graphics.FromImage(bit)
            'Added a checked panel to the list
            Player2DotsL.Add(DirectCast(sender, Panel))
            g.FillEllipse(pRed, New Rectangle(5, 5, 10, 10))
            DirectCast(sender, Panel).BackgroundImage = bit
            DirectCast(sender, Panel).Enabled = False
            LapTest()
        End If

    End Sub

    Dim Player1CheckedList As New List(Of Panel)
    Dim Player2CheckedList As New List(Of Panel)

    Private Sub LapTest()
        Dim EdgeList As New List(Of Panel)
        'Adds elements adjacent to dots to the list
        If Not Player1DotsL.Count = 0 Then
            EdgeList.AddRange(Borders(Player1DotsL))
        End If
        If Not Player2DotsL.Count = 0 Then
            EdgeList.AddRange(Borders(Player2DotsL))
        End If


        Dim FreedomList As New List(Of List(Of Panel))
        FreedomList = freedomPoints(EdgeList)

        Dim GroupList As New List(Of List(Of Panel))

        If Player Then 'Green
            GroupList = Group(Player2DotsL)
            GroupList = GroupEdition(Player1DotsL, GroupList, EdgeList, FreedomList)
            'List all elements in groups that remain
            For i As Integer = 0 To GroupList.Count - 1
                'Draws lines and creates a list of tuples
                DrawLines(GroupList(i), Player1DotsL, Player1CheckedList)
                For j As Integer = 0 To GroupList(i).Count - 1
                    'Elements can repeat, so the loop checks if they are no longer listed
                    If Not Player1CheckedList.Contains(GroupList(i)(j)) Then
                        Player1CheckedList.Add(GroupList(i)(j)) 'dodaje element
                        GroupList(i)(j).Enabled = False
                        'The condition removes an item from the opponents list so it can't longer be used
                        If Not Player2DotsL.IndexOf(GroupList(i)(j)) = -1 Then
                            Player2DotsL.RemoveAt(Player2DotsL.IndexOf(GroupList(i)(j)))
                            Player1DotsL.Add(GroupList(i)(j)) 'Adds current player to the list
                        End If
                    End If
                Next
            Next
            'Change player if nothing is encircled
            If Not GroupList.Count > 0 Then
                Player = False
            End If
        Else 'Red
            GroupList = Group(Player1DotsL)
            GroupList = GroupEdition(Player2DotsL, GroupList, EdgeList, FreedomList)
            'List all elements in groups that remain
            For i As Integer = 0 To GroupList.Count - 1
                'Draws lines and creates a list of tuples
                DrawLines(GroupList(i), Player2DotsL, Player2CheckedList)
                For j As Integer = 0 To GroupList(i).Count - 1
                    'Elements can repeat, so the loop checks if they are no longer listed
                    If Not Player2CheckedList.Contains(GroupList(i)(j)) Then
                        Player2CheckedList.Add(GroupList(i)(j)) 'dodaje element
                        GroupList(i)(j).Enabled = False
                        'The condition removes an item from the opponents list so it can't longer be used
                        If Not Player1DotsL.IndexOf(GroupList(i)(j)) = -1 Then
                            Player1DotsL.RemoveAt(Player1DotsL.IndexOf(GroupList(i)(j))) 'remove
                            Player2DotsL.Add(GroupList(i)(j)) 'Adds current player to the list
                        End If
                    End If
                Next
            Next
            'Change player if nothing is encircled
            If Not GroupList.Count > 0 Then
                Player = True
            End If
        End If
    End Sub



    Private Sub DrawLines(ByRef pane As List(Of Panel), ByRef PlayerList As List(Of Panel), ByRef cList As List(Of Panel))

        Dim d As Graphics
        d = Main_board.CreateGraphics()

        Dim OrderedPanelsList As New List(Of Panel)

        'Creates a list of all group panels without repetition
        For i As Integer = 0 To pane.Count - 1
            If Not OrderedPanelsList.Contains(pane(i)) Then
                OrderedPanelsList.Add(pane(i))
            End If
        Next

        Dim adjacentPanList As New List(Of Panel) 'List of adjacent panels
        For k As Integer = 0 To OrderedPanelsList.Count - 1

            Dim positionX As Integer = 0
            Dim positionY As Integer = 0
            For i As Integer = 0 To PLocationList.Count - 1
                For j As Integer = 0 To PLocationList(i).Count - 1
                    If PLocationList(i)(j).Name = OrderedPanelsList(k).Name Then
                        positionX = i
                        positionY = j
                    End If
                Next
            Next
            If PlayerList.Contains(PLocationList(positionX - 1)(positionY)) Then
                adjacentPanList.Add(PLocationList(positionX - 1)(positionY))
            End If
            If PlayerList.Contains(PLocationList(positionX + 1)(positionY)) Then
                adjacentPanList.Add(PLocationList(positionX + 1)(positionY))
            End If
            If PlayerList.Contains(PLocationList(positionX)(positionY + 1)) Then
                adjacentPanList.Add(PLocationList(positionX)(positionY + 1))
            End If
            If PlayerList.Contains(PLocationList(positionX)(positionY - 1)) Then
                adjacentPanList.Add(PLocationList(positionX)(positionY - 1))
            End If
        Next
        Dim AllLinesList As New List(Of Tuple(Of Panel, Panel))
        For k As Integer = 0 To adjacentPanList.Count - 1
            If Not cList.Contains(adjacentPanList(k)) Then
                Dim positionX As Integer = 0
                Dim positionY As Integer = 0
                For i As Integer = 0 To PLocationList.Count - 1
                    For j As Integer = 0 To PLocationList(i).Count - 1
                        If PLocationList(i)(j).Name = adjacentPanList(k).Name Then
                            positionX = i
                            positionY = j
                        End If
                    Next
                Next
                If adjacentPanList.Contains(PLocationList(positionX - 1)(positionY)) And
                    Not cList.Contains(PLocationList(positionX - 1)(positionY)) Then
                    AllLinesList.Add(Tuple.Create(adjacentPanList(k), PLocationList(positionX - 1)(positionY)))
                End If
                If adjacentPanList.Contains(PLocationList(positionX + 1)(positionY)) And
                    Not cList.Contains(PLocationList(positionX + 1)(positionY)) Then
                    AllLinesList.Add(Tuple.Create(adjacentPanList(k), PLocationList(positionX + 1)(positionY)))
                End If
                If adjacentPanList.Contains(PLocationList(positionX)(positionY + 1)) And
                    Not cList.Contains(PLocationList(positionX)(positionY + 1)) Then
                    AllLinesList.Add(Tuple.Create(adjacentPanList(k), PLocationList(positionX)(positionY + 1)))
                End If
                If adjacentPanList.Contains(PLocationList(positionX)(positionY - 1)) And
                    Not cList.Contains(PLocationList(positionX)(positionY - 1)) Then
                    AllLinesList.Add(Tuple.Create(adjacentPanList(k), PLocationList(positionX)(positionY - 1)))
                End If
                If adjacentPanList.Contains(PLocationList(positionX - 1)(positionY - 1)) And
                    Not cList.Contains(PLocationList(positionX - 1)(positionY - 1)) Then
                    AllLinesList.Add(Tuple.Create(adjacentPanList(k), PLocationList(positionX - 1)(positionY - 1)))
                End If
                If adjacentPanList.Contains(PLocationList(positionX + 1)(positionY + 1)) And
                    Not cList.Contains(PLocationList(positionX + 1)(positionY + 1)) Then
                    AllLinesList.Add(Tuple.Create(adjacentPanList(k), PLocationList(positionX + 1)(positionY + 1)))
                End If
                If adjacentPanList.Contains(PLocationList(positionX - 1)(positionY + 1)) And
                    Not cList.Contains(PLocationList(positionX - 1)(positionY + 1)) Then
                    AllLinesList.Add(Tuple.Create(adjacentPanList(k), PLocationList(positionX - 1)(positionY + 1)))
                End If
                If adjacentPanList.Contains(PLocationList(positionX + 1)(positionY - 1)) And
                    Not cList.Contains(PLocationList(positionX + 1)(positionY - 1)) Then
                    AllLinesList.Add(Tuple.Create(adjacentPanList(k), PLocationList(positionX + 1)(positionY - 1)))
                End If
            End If
        Next

        'We draw circles and lines
        For i As Integer = 0 To AllLinesList.Count - 1
            AllLinesList(i).Item1.Visible = False
            AllLinesList(i).Item2.Visible = False
            Application.DoEvents()
            If Player Then
                Dim myPen As Pen = New Pen(pGreen, 2)
                d.DrawLine(myPen, AllLinesList(i).Item1.Location.X + 10, AllLinesList(i).Item1.Location.Y + 10,
                           AllLinesList(i).Item2.Location.X + 10, AllLinesList(i).Item2.Location.Y + 10)
                d.FillEllipse(pGreen, New Rectangle(AllLinesList(i).Item1.Location.X + 5,
                                                    AllLinesList(i).Item1.Location.Y + 5, 10, 10))
                d.FillEllipse(pGreen, New Rectangle(AllLinesList(i).Item2.Location.X + 5,
                                                    AllLinesList(i).Item2.Location.Y + 5, 10, 10))
            Else
                Dim myPen As Pen = New Pen(pRed, 2)
                d.DrawLine(myPen, AllLinesList(i).Item1.Location.X + 10, AllLinesList(i).Item1.Location.Y + 10,
                           AllLinesList(i).Item2.Location.X + 10, AllLinesList(i).Item2.Location.Y + 10)
                d.FillEllipse(pRed, New Rectangle(AllLinesList(i).Item1.Location.X + 5,
                                                  AllLinesList(i).Item1.Location.Y + 5, 10, 10))
                d.FillEllipse(pRed, New Rectangle(AllLinesList(i).Item2.Location.X + 5,
                                                  AllLinesList(i).Item2.Location.Y + 5, 10, 10))
            End If
        Next

    End Sub

    Private Function GroupEdition(ByRef EnemyList As List(Of Panel), ByRef Groups As List(Of List(Of Panel)),
                                  ByRef EdgeList As List(Of Panel), ByRef ZoneList As List(Of List(Of Panel))) As _
                                  List(Of List(Of Panel))
        'The loop checks each item and adds them to the groups
        Do
            Dim StartLoop As Boolean = False
            For k As Integer = Groups.Count - 1 To 0 Step -1
                For l As Integer = 0 To Groups(k).Count - 1
                    Dim positionX As Integer = 0
                    Dim positionY As Integer = 0
                    'Get the current position of our panel
                    For i As Integer = 0 To PLocationList.Count - 1
                        For j As Integer = 0 To PLocationList(i).Count - 1
                            If PLocationList(i)(j).Name = Groups(k)(l).Name Then
                                positionX = i
                                positionY = j
                            End If
                        Next
                    Next
                    Dim _continue As Boolean = True
                    For i As Integer = 0 To ZoneList.Count - 1
                        'The Group element touches the list of freedom items, which indicates that it is not encircled
                        If ZoneList(i).Contains(PLocationList(positionX - 1)(positionY)) Or
                            ZoneList(i).Contains(PLocationList(positionX + 1)(positionY)) Or
                            ZoneList(i).Contains(PLocationList(positionX)(positionY - 1)) Or
                            ZoneList(i).Contains(PLocationList(positionX)(positionY + 1)) Then
                            _continue = False
                            'Remove list from Groups
                            Groups.RemoveAt(k)
                            Exit For
                        End If
                    Next

                    If _continue = True Then
                        'Adds border lists
                        If EdgeList.Contains(PLocationList(positionX - 1)(positionY)) And
                            Not Groups(k).Contains(PLocationList(positionX - 1)(positionY)) Then
                            Groups(k).Add(PLocationList(positionX - 1)(positionY))
                            StartLoop = True
                            'It adds its own elements and does not add opponent elements
                        ElseIf Not EnemyList.Contains(PLocationList(positionX - 1)(positionY)) And
                            Not Groups(k).Contains(PLocationList(positionX - 1)(positionY)) Then
                            Groups(k).Add(PLocationList(positionX - 1)(positionY))
                            StartLoop = True
                        End If

                        If EdgeList.Contains(PLocationList(positionX + 1)(positionY)) And
                            Not Groups(k).Contains(PLocationList(positionX + 1)(positionY)) Then
                            Groups(k).Add(PLocationList(positionX + 1)(positionY))
                            StartLoop = True
                        ElseIf Not EnemyList.Contains(PLocationList(positionX + 1)(positionY)) And
                            Not Groups(k).Contains(PLocationList(positionX + 1)(positionY)) Then
                            Groups(k).Add(PLocationList(positionX + 1)(positionY))
                            StartLoop = True
                        End If

                        If EdgeList.Contains(PLocationList(positionX)(positionY + 1)) And
                            Not Groups(k).Contains(PLocationList(positionX)(positionY + 1)) Then
                            Groups(k).Add(PLocationList(positionX)(positionY + 1))
                            StartLoop = True
                        ElseIf Not EnemyList.Contains(PLocationList(positionX)(positionY + 1)) And
                            Not Groups(k).Contains(PLocationList(positionX)(positionY + 1)) Then
                            Groups(k).Add(PLocationList(positionX)(positionY + 1))
                            StartLoop = True
                        End If

                        If EdgeList.Contains(PLocationList(positionX)(positionY - 1)) And
                            Not Groups(k).Contains(PLocationList(positionX)(positionY - 1)) Then
                            Groups(k).Add(PLocationList(positionX)(positionY - 1))
                            StartLoop = True
                        ElseIf Not EnemyList.Contains(PLocationList(positionX)(positionY - 1)) And
                            Not Groups(k).Contains(PLocationList(positionX)(positionY - 1)) Then
                            Groups(k).Add(PLocationList(positionX)(positionY - 1))
                            StartLoop = True
                        End If
                    Else
                        Exit For
                    End If
                Next
            Next
            'The loop works until all elements are checked or no longer in the group
            If Groups.Count = 0 Then
                Exit Do
            ElseIf StartLoop = False Then
                Exit Do
            End If
        Loop
        Return Groups
    End Function


    'This function creates an initial group of dots
    Private Function Group(ByRef PlayerList As List(Of Panel)) As List(Of List(Of Panel))
        Dim Groups As New List(Of List(Of Panel))
        'Enumerates all opponent dots
        For k As Integer = 0 To PlayerList.Count - 1
            Dim _continue As Boolean = True 'Block, does not add dots if already in some group
            For i As Integer = 0 To Groups.Count - 1
                If Groups(i).Contains(PlayerList(k)) Then
                    _continue = False
                    Exit For
                End If
            Next
            If _continue = True Then
                Dim PointsList As New List(Of Panel)
                PointsList.Add(PlayerList(k))
                'Get dot position
                Dim positionX As Integer = 0
                Dim positionY As Integer = 0
                For i As Integer = 0 To PLocationList.Count - 1
                    For j As Integer = 0 To PLocationList(i).Count - 1
                        If PLocationList(i)(j).Name = PlayerList(k).Name Then
                            positionX = i
                            positionY = j
                        End If
                    Next
                Next
                'Connects adjacent points to a group
                If Not PointsList.Contains(PLocationList(positionX - 1)(positionY)) And
                    PlayerList.Contains(PLocationList(positionX - 1)(positionY)) Then
                    PointsList.Add(PLocationList(positionX - 1)(positionY))
                End If
                If Not PointsList.Contains(PLocationList(positionX + 1)(positionY)) And
                    PlayerList.Contains(PLocationList(positionX + 1)(positionY)) Then
                    PointsList.Add(PLocationList(positionX + 1)(positionY))
                End If
                If Not PointsList.Contains(PLocationList(positionX)(positionY + 1)) And
                    PlayerList.Contains(PLocationList(positionX)(positionY + 1)) Then
                    PointsList.Add(PLocationList(positionX)(positionY + 1))
                End If
                If Not PointsList.Contains(PLocationList(positionX)(positionY - 1)) And
                    PlayerList.Contains(PLocationList(positionX)(positionY - 1)) Then
                    PointsList.Add(PLocationList(positionX)(positionY - 1))
                End If
                'Adds points to our list
                Groups.Add(PointsList)
            End If
        Next

        For i As Integer = 0 To Groups.Count - 1
            For j As Integer = 0 To Groups(i).Count - 1
                Dim PFGroup As Panel = Groups(i)(j)
                For r As Integer = 0 To Groups.Count - 1
                    If Not r = i And Groups(r).Contains(PFGroup) Then
                        'Merge lists
                        Groups(i).AddRange(Groups(r))
                        Groups(r).Clear()
                    End If
                Next
            Next
        Next
        'Removes empty lists
        For i As Integer = Groups.Count - 1 To 0 Step -1
            If Groups(i).Count = 0 Then
                Groups.RemoveAt(i)
            End If
        Next
        Return Groups
    End Function


    'Points of freedom
    Private Function freedomPoints(ByRef adjacent As List(Of Panel)) As List(Of List(Of Panel))
        Dim PanelsList As New List(Of List(Of Panel))

        Dim ListLength As Integer = PLocationList(0).Count
        Dim ListSize As Integer = PLocationList.Count
        'Adding elements from bottom
        For i As Integer = ListSize - 1 To 0 Step -1
            Dim lista As New List(Of Panel)
            For j As Integer = ListLength - 1 To 0 Step -1
                If Not adjacent.Contains(PLocationList(i)(j)) Then
                    lista.Add(PLocationList(i)(j))
                Else
                    Exit For
                End If

            Next
            PanelsList.Add(lista)
        Next
        'Adding elements from above
        For i As Integer = 0 To ListSize - 1
            Dim lista As New List(Of Panel)
            For j As Integer = 0 To ListLength - 1
                If Not adjacent.Contains(PLocationList(i)(j)) Then
                    lista.Add(PLocationList(i)(j))
                Else
                    Exit For
                End If

            Next
            PanelsList.Add(lista)
        Next
        'Adding elements from right side
        For i As Integer = ListLength - 1 To 0 Step -1
            Dim lista As New List(Of Panel)
            For j As Integer = ListSize - 1 To 0 Step -1
                If Not adjacent.Contains(PLocationList(j)(i)) Then
                    lista.Add(PLocationList(j)(i))
                Else
                    Exit For
                End If
            Next
            PanelsList.Add(lista)
            If i = ListSize Then
                Exit For
            End If
        Next
        'Adding elements from left side
        For i As Integer = 0 To ListLength - 1
            Dim lista As New List(Of Panel)
            For j As Integer = 0 To ListSize - 1
                If Not adjacent.Contains(PLocationList(j)(i)) Then
                    lista.Add(PLocationList(j)(i))
                Else
                    Exit For
                End If
            Next
            PanelsList.Add(lista)
            If i = ListSize Then
                Exit For
            End If
        Next
        Return PanelsList
    End Function


    'The function returns elements adjacent to dots
    Private Function Borders(ByRef PlayerList As List(Of Panel)) As List(Of Panel)
        Dim BorderList As New List(Of Panel) 'hold adjacent items
        For k As Integer = 0 To PlayerList.Count - 1

            Dim positionX As Integer = 0
            Dim positionY As Integer = 0
            'Get actual panel position
            For i As Integer = 0 To PLocationList.Count - 1
                For j As Integer = 0 To PLocationList(i).Count - 1
                    If PLocationList(i)(j).Name = PlayerList(k).Name Then
                        positionX = i
                        positionY = j
                    End If
                Next
            Next
            'Check that there are empty elements from left, right, top and bottom
            If Not BorderList.Contains(PLocationList(positionX - 1)(positionY)) And
                Not Player1DotsL.Contains(PLocationList(positionX - 1)(positionY)) And
                Not Player2DotsL.Contains(PLocationList(positionX - 1)(positionY)) Then
                BorderList.Add(PLocationList(positionX - 1)(positionY))
            End If
            If Not BorderList.Contains(PLocationList(positionX + 1)(positionY)) And
                Not Player1DotsL.Contains(PLocationList(positionX + 1)(positionY)) And
                Not Player2DotsL.Contains(PLocationList(positionX + 1)(positionY)) Then
                BorderList.Add(PLocationList(positionX + 1)(positionY))
            End If
            If Not BorderList.Contains(PLocationList(positionX)(positionY + 1)) And
                Not Player1DotsL.Contains(PLocationList(positionX)(positionY + 1)) And
                Not Player2DotsL.Contains(PLocationList(positionX)(positionY + 1)) Then
                BorderList.Add(PLocationList(positionX)(positionY + 1))
            End If
            If Not BorderList.Contains(PLocationList(positionX)(positionY - 1)) And
                Not Player1DotsL.Contains(PLocationList(positionX)(positionY - 1)) And
                Not Player2DotsL.Contains(PLocationList(positionX)(positionY - 1)) Then
                BorderList.Add(PLocationList(positionX)(positionY - 1))
            End If
        Next
        Return BorderList
    End Function
End Class
